/*+-------------------------------------------------------------------------------------+*/
/*|			F																		|*/
/*|	NX	FCRs232c																|*/
/*|	t@CTvFRS232cp̃NX													|*/
/*|	TAB			F4																		|*/
/*|			F1997.01.10`	cFiSSEj	VK쐬								|*/
/*|				F1998.05.07	@iSSEj	NX								|*/
/*|	Copyright	F1997-1998 Sanki System Engineering Co.Ltd.							|*/
/*+-------------------------------------------------------------------------------------+*/

#include	"stdafx.h"
#include	<string.h>
#include	<stdio.h>
#include	<stdlib.h>


#include	"Rs232c.h"

///////////////////////////////////////////////////////////////////////////////////////////
//		Life Cycle

/*+-------------------------------------------------------------------------------------+*/
/*|	TvF	P																	|*/
/*|	F	VA|[gI[v񂵂ɂꍇ									|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
CRs232c::CRs232c
	(
	)
/*+-------------------------------------------------------------------------------------+*/
{
	m_hCom   = NULL;
	m_hRead  = NULL;
	m_hWrite = NULL;
}

/*+-------------------------------------------------------------------------------------+*/
/*|	TvF	Q																	|*/
/*|	F	VA|[gI[vƓɍsꍇ										|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
CRs232c::CRs232c									//ԂlȂ
	(	char* r_szName,								// VA|[g()
		int  r_nInputBuffer,						// ̓obt@
		int  r_nOutputBuffer						// o̓obt@
	)
/*+-------------------------------------------------------------------------------------+*/
{
	m_hCom   = NULL;
	m_hRead  = NULL;
	m_hWrite = NULL;

	OpenCommPort(r_szName, r_nInputBuffer, r_nOutputBuffer);
}

/*+-------------------------------------------------------------------------------------+*/
/*|	TvF	폜																	|*/
/*|	F																				|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
CRs232c::~CRs232c									//ԂlȂ
	(
	)
/*+-------------------------------------------------------------------------------------+*/
{
}

///////////////////////////////////////////////////////////////////////////////////////////
//		operator

//Ȃ

///////////////////////////////////////////////////////////////////////////////////////////
//		Functions

/*+-------------------------------------------------------------------------------------+*/
/*|	TvFVA|[g̃I[v														|*/
/*|	Fw肳ꂽ|[gI[vBăVAǂݏ						|*/
/*|		F֐ŎgpCxgIuWFNg쐬B								|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
BOOL CRs232c::OpenCommPort							// TRUE: FALSE:s
	(	char *r_szName,								// VA|[g
		int  r_nInputBuffer,						// ̓obt@
		int  r_nOutputBuffer						// o̓obt@
	)
/*+-------------------------------------------------------------------------------------+*/
{
	DWORD	dwError;

	// łɃI[vĂƂ
	if(m_hCom)return TRUE;

	/* |[gI[v */
	m_hCom = CreateFile( r_szName,			/* w|[g */
			GENERIC_READ|GENERIC_WRITE,		/* ݐp */
			0,								/* 񋤗L[h */
			0,								/* ZLeBȂ */
			OPEN_EXISTING,					/* ʐM̏ꍇ̌܂l */
			FILE_FLAG_OVERLAPPED,			/* overlapped I/O */
			0 );							/* ʐM̏ꍇ̌܂l */
	if( m_hCom == INVALID_HANDLE_VALUE )	{
		dwError = GetLastError();
//		printf( "\n<OpenCommPort-%u>  : CreateFile() Error", dwError );
		return( FALSE );
	}

	/* ReadCommBlockpCxg쐬 */
	m_hRead = CreateEvent(	NULL,				/* ZLeBȂ */	
							TRUE, 				/* Zbg */
							FALSE, 				/* ͔VOi */
							"Rs232cToRead" );	/* Cxg */
	
	if( m_hRead == NULL )	{
		dwError = GetLastError();
//		printf( "\n<OpenCommPort-%u>  : CreateEvent() Error", dwError );
		return( FALSE );
	}

	/* WriteCommBlockpCxg쐬 */
	m_hWrite = CreateEvent(	NULL,				/* ZLeBȂ */	
							TRUE, 				/* Zbg */
							FALSE, 				/* ͔VOi */
							"Rs232cToWrite" );	/* Cxg */
	
	if( m_hWrite == NULL )	{
		dwError = GetLastError();
//		printf( "\n<OpenCommPort-%u>  : CreateEvent() Error", dwError );
		return( FALSE );
	}

	// o̓obt@ݒ
	m_nInputBuffer  = r_nInputBuffer ;
	m_nOutputBuffer = r_nOutputBuffer;

	return( TRUE );
}

/*+-------------------------------------------------------------------------------------+*/
/*|	TvFVA|[g̃N[Y														|*/
/*|	Fw肳ꂽ|[gN[YBăVAǂݏ						|*/
/*|		F֐ŎgpCxgIuWFNgN[YB							|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
void CRs232c::CloseCommPort							//ԂlȂ
	(												//Ȃ
	)
/*+-------------------------------------------------------------------------------------+*/
{
	if(m_hCom){
		CloseHandle( m_hCom   );
		CloseHandle( m_hRead  );
		CloseHandle( m_hWrite );
	}
}

/*+-------------------------------------------------------------------------------------+*/
/*|	TvFVA|[g̏														|*/
/*|	Fw肳ꂽVA|[gB										|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
BOOL CRs232c::InitCommPort							//TRUE:I FALSE:ُI
	(	INIT_COMM_PAC *r_pac						//p[^\̂ւ̃|C^
	)
/*+-------------------------------------------------------------------------------------+*/
{
	COMMTIMEOUTS	CommTimeOuts;			/* ʐM^CAEg\ */
	DCB				CommDcb;				/* foCXRg[ubN\ */
	DWORD			dwError;

	/* ʐM}XN̓o^ */
	if( !SetCommMask( m_hCom,					/* COMnh */
			EV_RXCHAR )	) {					/* M */
		dwError = GetLastError();
//		printf( "\n<InitCommPort-%u>  : SetCommMask() Error", dwError );
		return( FALSE );
	}

	/* o̓obt@eʂ̐ݒ */
#if 1
	if( !SetupComm( m_hCom,					/* COMnh */
			2048L,							/* ̓obt@TCY */
			2048L ) ) {						/* o̓obt@TCY */
#else
	if( !SetupComm( m_hCom,					// COMnh
			m_nInputBuffer,					// ̓obt@TCY
			m_nOutputBuffer ) ) {			// o̓obt@TCY
#endif
		dwError = GetLastError();
		return( FALSE );
	}

	/* ^CAEg̐ݒ */
	CommTimeOuts.ReadIntervalTimeout = 0xffffffff;
	CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
	CommTimeOuts.ReadTotalTimeoutConstant = 0;
	CommTimeOuts.WriteTotalTimeoutMultiplier = 0;
	CommTimeOuts.WriteTotalTimeoutConstant = 20000;
	if( !SetCommTimeouts( m_hCom,				/* COMnh */
			&CommTimeOuts ) ) {				/* ʐM^CAEg\̂̃|C^ */
		dwError = GetLastError();
//		printf( "\n<InitCommPort-%u>  : SetCommTimeOuts() Error", dwError );
		return( FALSE );
	}

	/* ʐMfoCX̐ݒǂݍ */
	GetCommState(	m_hCom,						/* COMnh */
					&CommDcb );					/* foCXRg[ubN\̂̃|C^ */

	/* ݒ */
	CommDcb.DCBlength = sizeof( DCB );		/* DCB\̃TCY */
	CommDcb.BaudRate  = r_pac->BaudRate;	/* ʐMx */
	CommDcb.fBinary   = TRUE;				/* oCi[h */
	CommDcb.fParity	  = TRUE;				/* peB`FbNL */
	CommDcb.ByteSize  = r_pac->ByteSize;	/* oCgf[^̃rbg */
	CommDcb.Parity    = r_pac->Parity;		/* peB */
	CommDcb.StopBits  = r_pac->StopBits;	/* Xgbvrbg */
	if( !SetCommState( m_hCom,				/* COMnh */
			&CommDcb ) ) {					/* foCXRg[ubN\̂̃|C^ */ 
		dwError = GetLastError();
//		printf( "\n<InitCommPort-%u>  : SetCommState() Error", dwError );
		return( FALSE );
	}

	return( TRUE );
}

/*+-------------------------------------------------------------------------------------+*/
/*|	TvFVA|[ĝPoCgǂݍ											|*/
/*|	Fw肳ꂽVA|[gPoCgf[^ǂݍ							|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
int CRs232c::ReadComm								//0:I -1:ُI -2:^CAEg
	(	DWORD dwTimeOut,							//^CAEgl(msP)
		LPSTR lpszBlock								//ǂݍݗ̈
	)
/*+-------------------------------------------------------------------------------------+*/
{
	DWORD	i;
	char szOutput[2];
	szOutput[1] = '\0';

	for( i = 0; i < dwTimeOut; i += 10 ) {	/* POɃ`FbN */
		if( ReadCommBlock( /*lpszBlock*/szOutput, 1 ) ){
			*lpszBlock = szOutput[0];
			break;
		}
		Sleep( 10 );		/* PO˂ */
	}

	return( i < dwTimeOut ? 0 : -2 );
}

/*+-------------------------------------------------------------------------------------+*/
/*|	TvFVA|[g̓ǂݍ													|*/
/*|	Fw肳ꂽVA|[gf[^ǂݍ									|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
int CRs232c::ReadCommBlock							//ۂɓǂݍ񂾃TCY
	(	LPSTR lpszBlock,							//ǂݍݗ̈
		int nMaxLength								//őǂݍ݃TCY
	)
/*+-------------------------------------------------------------------------------------+*/
{
	BOOL       fReadStat ;
	COMSTAT    ComStat ;
	DWORD      dwErrorFlags;
	DWORD      dwLength;
	DWORD      dwError;
	OVERLAPPED	Overlapped;

	Overlapped.hEvent = m_hRead;
	Overlapped.Offset = 0;
	Overlapped.OffsetHigh = 0;

	// only try to read number of bytes in queue 
	ClearCommError( m_hCom, &dwErrorFlags, &ComStat ) ;
	dwLength = min( (DWORD) nMaxLength, ComStat.cbInQue ) ;

	if ( dwLength > 0 )
	{
		fReadStat = ReadFile( m_hCom, lpszBlock,
		                    dwLength, &dwLength, &Overlapped ) ;
		if ( !fReadStat ) {
			if (GetLastError() == ERROR_IO_PENDING)	{
				// We have to wait for read to complete. 
				// This function will timeout according to the
				// CommTimeOuts.ReadTotalTimeoutConstant variable
				// Every time it times out, check for port errors
				while(!GetOverlappedResult( m_hCom, 
					&Overlapped, &dwLength, TRUE ) ) {
					dwError = GetLastError();
					if(dwError == ERROR_IO_INCOMPLETE)
						// normal result if not finished
						continue;
					else {
//						printf( "\n<ReadCommBlock-%u> GetOverlappedResult() Error", dwError );
						break;
					}
				}
					
			}
			else {
			    // some other error occurred
			    dwLength = 0 ;
				ClearCommError( m_hCom, &dwErrorFlags, &ComStat ) ;
				if ( dwErrorFlags > 0 ) {
//					printf( "<ReadCommBlock-%u> ReadFile() Error", dwErrorFlags ) ;
				}
			}
		}
	}

	return ( dwLength ) ;
}

/*+-------------------------------------------------------------------------------------+*/
/*|	TvFVA|[g̏													|*/
/*|	Fw肳ꂽVA|[gɑ΂ăf[^								|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
BOOL CRs232c::WriteCommBlock						//TRUE:I  FALSE:ُI
	(	LPSTR lpByte,								//݃f[^̈
		DWORD dwBytesToWrite						//݃f[^TCY
	)
/*+-------------------------------------------------------------------------------------+*/
{
	BOOL		fWriteStat ;
	DWORD		dwBytesWritten ;
	DWORD		dwErrorFlags;
	DWORD		dwError;
	COMSTAT 	ComStat;
	OVERLAPPED	Overlapped;

	if(!m_hCom)return FALSE;
	Overlapped.hEvent = m_hWrite;
	Overlapped.Offset = 0;
	Overlapped.OffsetHigh = 0;

	fWriteStat = WriteFile( m_hCom, lpByte, dwBytesToWrite,
	                       &dwBytesWritten, &Overlapped ) ;

	dwError = GetLastError();
	// Note that normally the code will not execute the following
	// because the driver caches write operations. Small I/O requests 
	// (up to several thousand bytes) will normally be accepted 
	// immediately and WriteFile will return true even though an
	// overlapped operation was specified

	if ( !fWriteStat ) {
		if( GetLastError() == ERROR_IO_PENDING ) {
			// We should wait for the completion of the write operation
			// so we know if it worked or not

			// This is only one way to do this. It might be beneficial to 
			// the to place the writing operation in a separate thread 
			// so that blocking on completion will not negatively 
			// affect the responsiveness of the UI

			// If the write takes long enough to complete, this 
			// function will timeout according to the
			// CommTimeOuts.WriteTotalTimeoutConstant variable.
			// At that time we can check for errors and then wait 
			// some more.

			while( !GetOverlappedResult( m_hCom,
				&Overlapped, &dwBytesWritten, TRUE ) ) {
				dwError = GetLastError();
				if( dwError == ERROR_IO_INCOMPLETE )
					// normal result if not finished
					continue;
				else {
					// an error occurred, try to recover
//					printf( "\n<WriteCommBlock-%u>", dwError ) ;
					ClearCommError( m_hCom, &dwErrorFlags, &ComStat ) ;
					if ( dwErrorFlags > 0 )
//						printf( " <WriteCommBlock-%u>", dwErrorFlags ) ;
					break;
				}
			}
		}
		else {						 	
			// some other error occurred
			ClearCommError( m_hCom, &dwErrorFlags, &ComStat ) ;
			if ( dwErrorFlags > 0 )
//				printf( "\n<WriteCommBlock-%u>", dwErrorFlags ) ;
			return ( FALSE );
		}
	}
	return ( TRUE ) ;
}

/*+-------------------------------------------------------------------------------------+*/
/*|	TvFabbZo																	|*/
/*|	F`f[^BytePʂŔrI_aZAPByteBCC߂B				|*/
/*|		F(codeo܂)̎I[o[t[͖B							|*/
/*|	lF																				|*/
/*|	F																				|*/
/*|	I/F F																				|*/
UCHAR CRs232c::GetBcc								//Zoabbl
	(	LPSTR ptr,									//`FbNΏۗ̈擪AhX
		UCHAR code									//`FbNIR[h
	)
/*+-------------------------------------------------------------------------------------+*/
{
	int		i = 0;
	UCHAR	bcc;

	bcc = ptr[i++];	
	for( ; ptr[i] != code; i++ ) {
		bcc	= bcc ^ ptr[i];
	}
	return( bcc ^ ptr[i] );
}
